/*
 * KROC translator: Function definitions and prototypes
 *
 * $Source: /extra/play/cvs/kroc/src/octran.h,v $
 *
 * $Id: octran.h,v 1.2 1999/09/08 17:00:29 rivimey Exp $
 *
 * arm-ops.c
 * (C) Copyright 1999 R. Ivimey-Cook <ruthc@sharra.demon.co.uk>
 *
 */


#include "ops.h"
#include "arm-ops.h"


OpcodesProcVec ArmOpcodes =
{
    "ARM",
    0,
    
    ArmDescribeTarget,
    ArmInit,
    ArmClose,

    ArmADC,		/* ADC */
    ArmADD,		/* ADD */
    ArmAJW,		/* AJW */
    ArmALT,		/* ALT */
    ArmALTEND,		/* ALTEND */
    ArmALTWT,		/* ALTWT */
    ArmAND,		/* AND */
    ArmBCNT,		/* BCNT */
    ArmBITCNT,		/* BITCNT */
    ArmBITREVNBITS,	/* BITREVNBITS */
    ArmBITREVWORD,	/* BITREVWORD */
    ArmBSUB,		/* BSUB */
    ArmCALL,		/* CALL */
    ArmCAUSEERROR,	/* CAUSEERROR */
    ArmCB,		/* CB */
    ArmCBU,		/* CBU */
    ArmCCNT1,		/* CCNT1 */
    ArmCFLERR,		/* CFLERR */
    ArmCJ,		/* CJ */
    ArmCLRHALTERR,	/* CLRHALTERR */
    ArmCRCBYTE,		/* CRCBYTE */
    ArmCRCWORD,		/* CRCWORD */
    ArmCS,		/* CS */
    ArmCSNGL,		/* CSNGL */
    ArmCSU,		/* CSU */
    ArmCSUB0,		/* CSUB0 */
    ArmCWORD,		/* CWORD */
    ArmDIFF,		/* DIFF */
    ArmDISC,		/* DISC */
    ArmDISS,		/* DISS */
    ArmDIST,		/* DIST */
    ArmDIV,		/* DIV */
    ArmDUP,		/* DUP */
    ArmENBC,		/* ENBC */
    ArmENBS,		/* ENBS */
    ArmENBT,		/* ENBT */
    ArmENDP,		/* ENDP */
    Unimplemented,	/* FMUL -- FPU */
    Unimplemented,	/* FPUABS -- FPU */
    Unimplemented,	/* FPADD -- FPU */
    Unimplemented,	/* FPADDDBSN -- FPU */
    Unimplemented,	/* FPB32TOR64 -- FPU */
    Unimplemented,	/* FPCHKERR -- FPU */
    Unimplemented,	/* FPUCHKI32 -- FPU */
    Unimplemented,	/* FPUCHKI64 -- FPU */
    Unimplemented,	/* FPDIV -- FPU */
    Unimplemented,	/* FPUDIVBY2 -- FPU */
    Unimplemented,	/* FPDUP -- FPU */
    Unimplemented,	/* FPENTRY -- FPU */
    Unimplemented,	/* FPEQ -- FPU */
    Unimplemented,	/* FPUEXPDEC32 -- FPU */
    Unimplemented,	/* FPUEXPINC32 -- FPU */
    Unimplemented,	/* FPGE -- FPU */
    Unimplemented,	/* FPGT -- FPU */
    Unimplemented,	/* FPI32TOR32 -- FPU */
    Unimplemented,	/* FPI32TOR64 -- FPU */
    Unimplemented,	/* FPINT -- FPU */
    Unimplemented,	/* FPLDNLADDDB -- FPU */
    Unimplemented,	/* FPLDNLADDSN -- FPU */
    Unimplemented,	/* FPLDNLDB -- FPU */
    Unimplemented,	/* FPLDNLDBI -- FPU */
    Unimplemented,	/* FPLDNLMULDB -- FPU */
    Unimplemented,	/* FPLDNLMULSN -- FPU */
    Unimplemented,	/* FPLDNLSN -- FPU */
    Unimplemented,	/* FPLDNLSNI -- FPU */
    Unimplemented,	/* FPLDZERODB -- FPU */
    Unimplemented,	/* FPLDZEROSN -- FPU */
    Unimplemented,	/* FPLG -- FPU */
    Unimplemented,	/* FPMUL -- FPU */
    Unimplemented,	/* FPUMULBY2 -- FPU */
    Unimplemented,	/* FPNAN -- FPU */
    Unimplemented,	/* FPNOTFINITE -- FPU */
    Unimplemented,	/* FPORDERED -- FPU */
    Unimplemented,	/* FPUR32TOR64 -- FPU */
    Unimplemented,	/* FPUR64TOR32 -- FPU */
    Unimplemented,	/* FPREM -- FPU */
    Unimplemented,	/* FPREMFIRST -- FPU */
    Unimplemented,	/* FPREMSTEP -- FPU */
    Unimplemented,	/* FPREV -- FPU */
    Unimplemented,	/* FPURM -- FPU */
    Unimplemented,	/* FPURN -- FPU */
    Unimplemented,	/* FPURP -- FPU */
    Unimplemented,	/* FPRTOI32 -- FPU */
    Unimplemented,	/* FPURZ -- FPU */
    Unimplemented,	/* FPSTNLDB -- FPU */
    Unimplemented,	/* FPSTNLI32 -- FPU */
    Unimplemented,	/* FPSTNLSN -- FPU */
    Unimplemented,	/* FPSUB -- FPU */
    Unimplemented,	/* FPTESTERR -- FPU */
    Unimplemented,	/* FPUCLRERR -- FPU */
    Unimplemented,	/* FPUNOROUND -- FPU */
    Unimplemented,	/* FPUSETERR -- FPU */
    Unimplemented,	/* FPUSQRTFIRST -- FPU */
    Unimplemented,	/* FPUSQRTLAST -- FPU */
    Unimplemented,	/* FPUSQRTSTEP -- FPU */
    ArmGAJW,		/* GAJW */
    ArmGCALL,		/* GCALL */
    ArmGT,		/* GT */
    ArmGTU,		/* GTU */
    ArmIN,		/* IN */
    ArmJ,		/* J */
    ArmLADD,		/* LADD */
    ArmLB,		/* LB */
    ArmLBX,		/* LBX */
    ArmLDC,		/* LDC */
    ArmLDCNT,		/* LDCNT */
    ArmLDIFF,		/* LDIFF */
    ArmLDINF,		/* LDINF */
    ArmLDIV,		/* LDIV */
    ArmLDL,		/* LDL */
    ArmLDLP,		/* LDLP */
    ArmLDNL,		/* LDNL */
    ArmLDNLP,		/* LDNLP */
    ArmLDPI,		/* LDPI */
    ArmLDPRI,		/* LDPRI */
    ArmLDTH,		/* LDTH */
    ArmLDTIMER,		/* LDTIMER */
    ArmLEND,		/* LEND */
    ArmLMUL,		/* LMUL */
    ArmLS,		/* LS */
    ArmLSHL,		/* LSHL */
    ArmLSHR,		/* LSHR */
    ArmLSUB,		/* LSUB */
    ArmLSUM,		/* LSUM */
    ArmLSX,		/* LSX */
    ArmMINT,		/* MINT */
    ArmMOVE,		/* MOVE */
    ArmMOVE2DALL,	/* MOVE2DALL -- MOVE2D */
    ArmMOVE2DINIT,	/* MOVE2DINIT -- MOVE2D */
    ArmMOVE2DNONZERO,	/* MOVE2DNONZERO -- MOVE2D */
    ArmMOVE2DZERO,	/* MOVE2DZERO -- MOVE2D */
    ArmMUL,		/* MUL */
    ArmNFIX,		/* NFIX */
    ArmNORM,		/* NORM */
    ArmNOT,		/* NOT */
    ArmOPR,		/* OPR */
    ArmOR,		/* OR */
    ArmOUT,		/* OUT */
    ArmOUTBYTE,		/* OUTBYTE */
    ArmOUTWORD,		/* OUTWORD */
    ArmPFIX,		/* PFIX */
    ArmPOSTNORMSN,	/* POSTNORMSN */
    ArmPROD,		/* PROD */
    ArmREM,		/* REM */
    ArmRESETCH,		/* RESETCH */
    ArmRET,		/* RET */
    ArmREV,		/* REV */
    ArmROUNDSN,		/* ROUNDSN */
    ArmRUNP,		/* RUNP */
    ArmSAVEH,		/* SAVEH */
    ArmSAVEL,		/* SAVEL */
    ArmSB,		/* SB */
    ArmSETERR,		/* SETERR */
    ArmSETHALTERR,	/* SETHALTERR */
    ArmSHL,		/* SHL */
    ArmSHR,		/* SHR */
    ArmSS,		/* SS */
    ArmSSUB,		/* SSUB */
    ArmSTARTP,		/* STARTP */
    ArmSTHB,		/* STHB */
    ArmSTHF,		/* STHF */
    ArmSTL,		/* STL */
    ArmSTLB,		/* STLB */
    ArmSTLF,		/* STLF */
    ArmSTNL,		/* STNL */
    ArmSTOPERR,		/* STOPERR */
    ArmSTOPP,		/* STOPP */
    ArmSTTIMER,		/* STTIMER */
    ArmSUB,		/* SUB */
    ArmSUM,		/* SUM */
    ArmTALT,		/* TALT */
    ArmTALTWT,		/* TALTWT */
    ArmTESTERR,		/* TESTERR */
    ArmTESTHALTERR,	/* TESTHALTERR */
    ArmTESTPRANAL,	/* TESTPRANAL */
    ArmTIN,		/* TIN */
    ArmUNPACKSN,	/* UNPACKSN */
    ArmVIN,		/* VIN */
    ArmVOUT,		/* VOUT */
    ArmWCNT,		/* WCNT */
    ArmWSUB,		/* WSUB */
    ArmWSUBDB,		/* WSUBDB */
    ArmXDBLE,		/* XDBLE */
    ArmXOR,		/* XOR */
    ArmXSWORD,		/* XSWORD */
    ArmXWORD,		/* XWORD */
};

