/*
 * KROC translator: Global variables.
 *
 * $Source: /extra/play/cvs/kroc/src/host/data.c,v $
 *
 * $Id: data.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * (C) Copyright 1995,1996,1997 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * Mostly independent of target.
 */

static char data_c_rcsid[] = "$Id: data.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

#include "octran.h"

int istackp = 0;                /* evaluation stack pointer */
int fstackp = 0;                /* f.p. stack pointer */
int comma = 0;                  /* between operands */
int iline = 0;                  /* input line number */
int oline = 0;                  /* output line number */
int fline = 0;                  /* occam source file line number */
int ishuff = 0;                 /* expect stack overflow following ENBC, DISC, etc. */
int shufflecount = 0;           /* number of shuffles */
int lshufflecount = 0;          /* number of label shuffles */

FILE *in = 0 /* stdin */;               /* input file -- can't statically initialise */
FILE *out = 0 /* stdout */;             /* output file -- can't statically initialise */

char *source = (char*)"<stdin>";
char *dest = (char*)"<stdout>";

int ws = 0;                     /* workspace */
int vs = 0;                     /* vector space */

/*      Options.                        */
/*      Some may depend on target.      */

int o_kjumptable = False;       /* symbolic entry to kernel */
int o_checks = CH_TRAP;         /* check level */
int o_hardware = True;          /* hardware arithmetic */
int o_stackws = True;           /* occam WS on C stack */
int o_time = True;              /* real time */
#if defined(TARGET_CPU_ALPHA)
int o_opt = False;              /* optimize conditions? */
#else
int o_opt = True;               /* optimize conditions? */
#endif
int o_verbose = False;          /* messages? */
int o_echo = False;             /* echo source? */
int o_lines = False;            /* line numbers? */
int o_global = False;           /* make PROC names global? */
int o_un = True;                /* trap on unimplemented/unrecognized instructions */
int o_reverse = True;           /* reverse endianism */
int o_lib = False;              /* library */
int o_abort = False;            /* abort on error */
int o_trunc = True;             /* truncate "%" names */
int o_mdp = True;               /* Micheal Poole's extra comments */
int o_real64 = False;		/* big-endian REAL64s */
int o_debug = False;		/* generate debugging directives */
int o_label = False;		/* optimize label differences */
int o_vptr = False;		/* FPtemp etc. relative to Vptr */
int o_resched = False;		/* reschedule on jumps */

int lcount = 0;                 /* count of LX labels */
int started = False;		/* generated any code yet? */
int cond = C_NONE;              /* pending condition for CJ */
#ifdef FLOAT
int sround = R_N;               /* target rounding mode */
#if defined(TARGET_CPU_ALPHA)
int rround = R_N;               /* ALPHA: remembered rounding mode */
#endif
#endif
int stcount = -1;               /* symbol table entries */

const char *ptype[4] = {        /* names of PROC types */
  "PROC",
  "FUNCTION",
  "EXTERNAL",
  "C_EXTERNAL"
};
