/*
 * KROC ALPHA translator: Deal with conditionals.
 *
 * $Source: /extra/play/cvs/kroc/src/target/alpha/cond.c,v $
 *
 * $Id: cond.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 */

static char cond_c_rcsid[] = "$Id: cond.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

#include "octran.h"
#if 0
cond_type condtab[C_SIZE] =

/*      Must be in true/false even/odd pairs    */

/*      {"name",    "branch",  "trap" } */      /* code */

{       {"...",     "...",     "..."   },       /*  0 */
	{"...",     "...",     "..."   },       /*  1 */

	{"GT",      "bgt",      "..."  },       /*  2 */
	{"LE",      "ble",      "..."  },       /*  3 */

	{"EQ",      "beq",      "..."  },       /*  4 */
	{"NE",      "bne",      "..."  },       /*  5 */

	{"GE",      "bge",      "..."  },       /*  6 */
	{"LT",      "blt",      "..."  },       /*  7 */

	{"VS",      "blbs",     "..."  },       /*  8 */
	{"VC",      "blbc",     "..."  },       /*  9 */

	{"GEU",     "bne",      "..."  },       /* 10 */
	{"LU",      "bne",      "..."  },       /* 11 */

	{"NEG",     "blt",      "..."  },       /* 12 */
	{"POS",     "bge",      "..."  },       /* 13 */

	{"FGT",     "fbne",      "..."  },      /* 14 */
	{"FLE",     "fbne",     "..."  },       /* 15 */

	{"FEQ",     "fbne",      "..."  },      /* 16 */
	{"FNE",     "fbne",     "..."  },       /* 17 */

	{"FO",      "...",      "..."  },       /* 18 */
	{"FU",      "...",      "..."  },       /* 19 */

	{"ALWAYS",  "br",       "..."  },       /* 20 */
	{"NEVER",   "! never",  "..."  }        /* 21 */
};
#endif

void defcond (c)                /* do deferred condition */
int c;
{
#if 0
	cond = C_NONE;
	if (c == C_ALWAYS)
	{       mnem("or"); Z; Trans_TRUE; A; COMMENT("deferred ALWAYS"); nl; }
	else if (c == C_NEVER)
	{       mnem("or"); Z; Trans_FALSE; A; COMMENT("deferred NEVER"); nl; }
	else
	{
		mnem("mov");  CC;  A; lineup();
		fprintf(out, "%c  deferred %s", CCHAR, condtab[c].name); nl;
	lab(1); nl;
	}
#endif
	fprintf(out, "Deferred condition optimisation not supported"); nl;

}

#if 0
void check (c, chk)             /* generate error-checking code */
int c, chk;
{
/* Unused */
#if 0
	static const char *chkname[6] =
	{       "SETERR",       /* 0 */
		"OFLOW",        /* 1 */
		"RANGE",        /* 2 */
		"FLOAT",        /* 3 */
		"UNREC",        /* 4 */
		"UNIMP"         /* 5 */
	};
#endif
	comma = 0;
	switch (o_checks)
	{
	case CH_NONE:
		dummy("checks off"); nl;
		break;
	case CH_SETFLAG:
		mnem(condtab[c].branch); CC; f(1); nl;
		SET_EFLAG
		lab(1); nl;
		break;
	case CH_TRAP:
		dummy("Trap error"); nl;
		mnem(condtab[c].branch); CC; f(1); nl;
		SET_EFLAG
		GEN_TRAP(chk);
		lab(1); nl;
		break;
	case CH_HALT:           /* should HALT on error, not TRAP */
		mnem(condtab[c].branch); CC; here(1); nl;
		SET_EFLAG
		TST_EFLAG(CC)
		mnem("beq"); CC; f(1); nl;
		GEN_TRAP(chk);
		lab(1); nl;             
		break;
	}
}
#endif
/*      See also CJ in "f_direct.c".    */
