/*
 * KROC ALPHA translator - "Direct" instructions (with explicit operands)
 *
 * $Source: /extra/play/cvs/kroc/src/target/alpha/f_direct.c,v $
 *
 * $Id: f_direct.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * ALPHA target only.
 */

static char f_direct_c_rcsid[] = "$Id: f_direct.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

#include <string.h>
#include "octran.h"

int ftype[4]; /* Types of f.p. registers */


int big (n, mbits)                     /* deal with big operands (16..32 bits) */
int n;
int mbits;                             /* may be 8 or 15 */
{
      int maxo = (1<<mbits)-1;         /* 255 or 32767 */
      int mino = -maxo;
      if (n < mino || n > maxo)
/*{{{  Carl's code*/
#if 0
	{
	    signed         int val, tmp1, tmp2;              /* signed 32 bit integer values */
	    signed short int low, high, extra;               /* signed 16 bit integer values */

	    /*  Load literal (32 bit value) 
	     *  Ref:  Alpha Architecture Handbook  Page A-13.
	     */
      #define SEXT16_32(expr) ( (((expr)>>15)&1) ? (((expr) & 0x0000ffff) | 0xffff0000) : ((expr) & 0x0000ffff)  )
      #define SI(expr)        ((signed int) (expr))
      #define UI(expr)        ((unsigned int) (expr))
      #define USI(expr)       ((unsigned short int) (expr))
      #define SSI(expr)       ((signed short int) (expr))

		val  = SI(n);
		low  = SSI(val & 0x0000ffff);

		tmp1 = val - SEXT16_32(low);

		high = SSI((tmp1 & 0xffff0000)>>16);
		tmp2 = tmp1 - ( SI((SEXT16_32(high)) ) );
		extra = 0;


  /* printf("n:%X  val:%X  low:%X  extra:%X  high:%X     tmp1:%X  tmp2:%X \n", n, val, low, extra, high, tmp1, tmp2); */
  /* printf("SEXT(low):%X  SEXT(high):%X \n", SEXT16_32(low), SEXT16_32(high)); */
  /* printf("n:%d  val:%d  low:%d  extra:%d  high:%d     tmp1:%d  tmp2:%d \n", n, val, low, extra, high, tmp1, tmp2); */


	       if (tmp2 != 0)
		    {
		       extra =  SSI(0x4000);
		       tmp1  = tmp1 - SI(0x40000000);
		       high = SSI((tmp1 & 0xffff0000) >> 16);
		       /* printf("extra:%X  high:%X\n", extra, high); */
		    }


		mnem("lda"); T0; index0(Zreg, low); COMMENT("big operand (low)"); NL;
		if (extra != 0) { mnem("ldah"); T0; index0(Temp0, extra);  COMMENT("big operand (extra)"); NL; }
		if (high  != 0) { mnem("ldah"); T0; index0(Temp0, high);   COMMENT("big operand (high)"); NL; }

		/* Correction for -ve values, sign-extend longword to quadword. */
		if (n < 0) { mnem("sll"); T0; dec(32); T0; nl; 
			     mnem("sra"); T0; dec(32); T0; nl; 
			   }

		return True;
	}
#endif
/*}}}  */
/*{{{  Michael's code*/
	{
	/*{{{  build it in parts*/
	/* algorithm revised from page A-13 of Alpha Architecture Handbook */
	/* this version produces fewer 'extra's than Carl's version */
	  int lowword, highword, extra, tmp1;
	  lowword = n & 0xFFFF;
	  extra = 0;
	  /*{{{  generate code to put opd into T0*/
	  if ((lowword & 0x8000) != 0)
	      lowword = lowword | 0xFFFF0000;  /* sign extend */
	  mnem("lda"); T0; index0(Zreg, lowword); COMMENT("big operand (low)"); NL;
	  tmp1 = n - lowword;  /*  reduce by sign-extended low word */
	  if (n >= 0x7FFF8000)
	  {
		extra = 0x4000;
		tmp1 = tmp1 - (extra << 16);
	  }
	  highword = tmp1 >> 16;
	  if (extra != 0)
	  { mnem("ldah"); T0; index0(Temp0, extra); COMMENT("big operand (extra)"); NL; }
	  if (highword != 0)
	  { mnem("ldah"); T0; index0(Temp0, highword); COMMENT("big operand (high)"); NL; }
	  /*}}}  */
	  /* explicit sign extension is not needed as LDAH does it already */
	/*}}}  */
	return True;
	}
/*}}}  */
	else
		return False;
}


/*   J:
 *   -
 *    Ref: (T9000 ISM  Page 349)
 *     
 *     if (n = 0)
 *        ...Breakpoint TRAP
 *     else
 *        Iptr' <- Next Instruction + n
 *     
 *     
 *     
 */
void J ()
{       reflab (0);
	mnem("br"); Z; str(b_operand); NL;
	istackp = 0;
	fstackp = 0;
	ishuff = 0;
	BREAK;
}

/*   LDLP:
 *   ----
 *    Ref: (T9000 ISM  Page 363)
 *     
 *     Areg' <- Wptr @ n
 *     Breg' <- Areg
 *     Creg' <- Breg
 *     
 */
void LDLP ()
{       int n = n_operand*BytesPerWord;
	PUSH;
	if (big (n,8))            /* "big" has side-effect, so can't take out common code */
	{       mnem("addl"); W; T0; }
	else if (n_operand > 0)
	{       mnem("addl"); W; dec(n); }
	else if (n_operand < 0)
	{       mnem("subl"); W; dec(-n); }
	else /* n_operand == 0 */
	{       mnem("mov"); W; }
	A; NL;
}

/*   PFIX:
 *   ----
 *    Ref: (T9000 ISM  Page)
 *     
 *     
 *     
 *     
 *     
 */
void PFIX ()
{       unimp ();
}

/*   LDNL:
 *   ----
 *    Ref: (T9000 ISM  Page 365)
 *     
 *     Areg' <- word[Areg @ n]
 *     
 *     
 *     
 */
void LDNL ()
{       int n = n_operand*BytesPerWord;
	if (big (n,15))
	{       mnem("addl"); A; T0; T0; NL; 
		mnem("ldl"); A; index1(Temp0, 0); }
	else
	{       mnem("ldl"); A; index1(Areg, n_operand); }
	NL;
}

/*   LDC:
 *   ---
 *    Ref: (T9000 ISM  Page 353)
 *     
 *     Areg' <- n
 *     Breg' <- Areg
 *     Creg' <- Breg
 *     
 */
void LDC ()
{       
	PUSH;
	if (!nflag)
	    {
	     int marker;

	       if (strchr(&b_operand[0], '-') != NULL)
		   {  /* Label difference */
		      marker = strspn(&b_operand[0], "L0123456789");
		      b_operand[marker] = 0; 
		      SYMBOLIC_OFFSET(&b_operand[0], &b_operand[marker+1]) 
		   }
	       else
		   {  /* Equated value (ASSUME: 16 bits) */
		      mnem("or");  Z;  str(b_operand);

		   }
	    }
	else if (n_operand == 0)
		mnem("clr");
	else if (big(n_operand,8))
	{       mnem("mov"); T0; }
	else if (n_operand < 0)
	{       mnem("subl"); Z; dec(-n_operand); }
	else
	{       mnem("or"); Z; dec(n_operand); }
	A; NL;
}

/*   LDNLP:
 *   -----
 *    Ref: (T9000 ISM  Page 366)
 *     
 *     Areg' <- Areg @ n
 *     
 *     
 *     
 */
void LDNLP ()
{       int n = n_operand*BytesPerWord;
	if (n_operand != 0)
	{       if (big (n,8))
		{       mnem("addl"); A; T0; }
		else if (n_operand > 0)
		{       mnem("addl"); A; dec(n); }
		else /* n_operand < 0 */
		{       mnem("subl"); A; dec(-n); }
		A;
	}
	else
		dummy("null operation");
	NL;
}

/*   NFIX:
 *   ----
 *    Ref: (T9000 ISM  Page )
 *     
 *     
 *     
 *     
 *     
 */
void NFIX ()
{       unimp ();
}

/*   LDL:
 *   ---
 *    Ref: (T9000 ISM  Page 362)
 *     
 *     Areg' <- word[Wptr @ n]
 *     Breg' <- Areg
 *     Creg' <- Breg
 *     
 */
void LDL ()
{       int n = n_operand*BytesPerWord;
	if (strcmp (&buffer[B_PROC], "-- throw the result away ") == 0)
		dummy("ignored");
	else
	{       PUSH;
		if (big (n,15))
		{       mnem("addl"); W; T0; T0; NL;
			mnem("ldl"); A; index1(Temp0, 0); }
		else
		{       mnem("ldl"); A; index1(Wptr, n_operand); }

	}
	NL;
}

/*   ADC:
 *   ---
 *    Ref: (T9000 ISM  Page 229)
 *     
 *     Areg' <- Areg +(checked) n
 *     
 *     
 *     
 */
void ADC ()
{       if (n_operand != 0)
	{       if (big (n_operand,8))
		{       mnem("addlv"); A; T0; }
		else if (n_operand > 0)
		{       mnem("addlv"); A; dec(n_operand); }
		else if (n_operand < 0)
		{       mnem("sublv"); A; dec(-n_operand); }
		A; NL;

	}
	else
	{       dummy("null operation"); NL; }
	if (strstr (b_comment, " check for replicator overflow") != NULL)
		POP;
}

/*   CALL:
 *   ----
 *    Ref: (T9000 ISM  Page 241)
 *     
 *     Wptr' <- Wptr @ -4
 *     
 *     word'[Wptr' @ 0] <- Iptr
 *     word'[Wptr' @ 1] <- Areg
 *     word'[Wptr' @ 2] <- Breg
 *     word'[Wptr' @ 3] <- Creg
 *     
 *     Iptr' <- next instruction + n
 *     
 *     Areg' <- Iptr
 *     
 */
void CALL ()                            /* unadjusted PC used internally */
{       int i, j, temp;
	/* Should leave return address in A as well as W[0] -   */
	/* but occam never uses this.                           */
	/*                                                      */
	/* Should also use adjusted PC, for consistency -       */

	for (i = 0; i <= stcount; ++i)  /* ?numerical order => binary search */
		if (strcmp (b_operand, proctab[i].label) == 0)
			break;
	if (i > stcount)
	{       fputs ("\n*** Call of undefined PROC/FUNCTION", stderr);
		mnem("subl"); W; dec(4*BytesPerWord); W; NL;
		for (j = 1; istackp > 0; ++j)
		{       mnem("stl"); A; index1(Wptr, j); nl;
			POP;
		}
		mnem("stl"); L; index1(Wptr, 0); nl;    /* unadjusted */
		CALL_RTN(b_operand);
		istackp = 0;
		fstackp = 0;
		ishuff = 0;
	}                                               /* call C function */
	else if (proctab[i].S_PTYPE == P_C_EXTERNAL)
	{       for (j = 1; istackp > 0; ++j)
		{       mnem("stl"); A; index1(Wptr, j - 4); NL;
			POP;
		}
		mnem("subl"); W; dec(3*BytesPerWord); P0; COMMENT("C parameter -> occam workspace"); NL;
		(void)strcpy(b_comment, &b_operand[0]);
		CCALL(proctab[i].proc);

		istackp = 0;
		fstackp = 0;
		ishuff = 0;
	}
	else                                     /* call occam PROC/FUNCTION */
	{       mnem("subl"); W; dec(4*BytesPerWord); W; NL;
		for (j = 1; istackp > 0; ++j)
		{       mnem("stl"); A; index1(Wptr, j); NL;
			POP;
		}

		mnem("lda"); RA; f(1); NL;
		mnem("stl"); RA; index1(Wptr, 0); NL;
		mnem("jsr"); RA;  

		/* mnem("br"); RA;  f(1); NL; */
		/*        lab(1); */
		/* mnem("addl"); RA; dec(3*BytesPerWord); RA; NL; */
		/* mnem("stl"); RA; index1(Wptr, 0); NL; */
		/* mnem("jsr"); RA;  */

		if (proctab[i].S_PTYPE == P_EXTERNAL)
		{       str(proctab[i].proc); COMMENT(b_operand); NL; }
		else
		{       str(b_operand); COMMENT(proctab[i].proc); NL; }

		lab(1);  nl;   /*  Return point  */

		istackp = proctab[i].S_ISTACK;
		fstackp = proctab[i].S_FSTACK;
		ishuff  = proctab[i].S_ISHUFF;
		temp    = proctab[i].S_FTYPES;
		for (j = 1; j <= fstackp; ++j)  /* at most one returned (ORTMS p.10) */
		{       ftype[j] = temp & 1;
			temp >>= 1;
		}
	}
	if (o_verbose)
	{       fprintf (stderr, "\n... Return from %s %s %s\n",
			b_operand, ptype[proctab[i].S_PTYPE], proctab[i].proc);
		fprintf (stderr, "    istack := %d, fstack := [", istackp);
		for (j = fstackp; j > 0; --j)
			fputc ((ftype[j] == F_D) ? 'D' : 'S', stderr);
		fputc (']', stderr);
		where ();
	}
}

/*   CJ:
 *   --
 *    Ref: (T9000 ISM  Page 249)
 *     
 *     if (Areg = 0)
 *        Iptr' <- next instruction + n
 *     else
 *        Iptr' <- next instruction
 *        Areg' <- Breg
 *        Breg' <- Creg
 *
 */
void CJ ()
{       int c = cond;
	reflab (istackp);
	#if 0
	/* o_opt not implemented for Alpha which has no special CC register */
	if (o_opt && (c != C_NONE))
	{       cond = C_NONE;
		if (c == C_ALWAYS)
			fputc (CCHAR, out);
		mnem(condtab[INV(c)].branch); CC; str(b_operand); lineup ();
			fprintf (out, "%c+  was %s", CCHAR, condtab[c].name);
		if (c < C_ALWAYS)
		{       NL;
			mnem("clr"); A; COMMENT("make sure false"); NL; 
		}
	}
	else
	#endif
	{       mnem("beq"); A; str(b_operand); NL;
	}
	NL;
	ishuff += 1;
	POP;
}

/*   AJW:
 *   ---
 *    Ref: (T9000 ISM  Page 231)
 *     
 *     Wptr' <- @ n
 *     
 *     
 *     
 */
void AJW ()
{       int n = n_operand*BytesPerWord;
	if (n_operand != 0)
	{       if (big (n,8))
		{       mnem("addl"); W; T0; }
		else if (n_operand > 0)
		{       mnem("addl"); W; dec(n); }
		else if (n_operand < 0)
		{       mnem("subl"); W; dec(-n); }
		W;
	}
	else
		dummy("null operation");
	NL;
}

/*   EQC:
 *   ---
 *    Ref: (T9000 ISM  Page 277)
 *     
 *     if (Areg = n)
 *       Areg' <- true
 *     else
 *       Areg <- false
 */
void EQC ()
{       if (big (n_operand,8))        /* loads T0 as side effect */
	{
	  mnem("cmpeq"); A; T0;
	}
	else if (n_operand < 0)
	{
	  mnem("subl"); Z; dec(-n_operand); T0; nl;
	  mnem("cmpeq"); A; T0;
	}
	else if (n_operand == 0)
	{
	  mnem("cmpeq"); Z; A;
	}
	else
	{
	  mnem("cmpeq"); A; dec(n_operand);
	}
	A; nl;
}

/*   STL:
 *   ---
 *    Ref: (T9000 ISM  Page 421)
 *     
 *     word'[Wptr @ n] <- Areg
 *     
 *     Areg' <- Breg
 *     Breg' <- Creg
 */
void STL ()
{       int n = n_operand*BytesPerWord;
	if (big (n,15))
	{       mnem("addl"); W; T0; T0; NL;
		mnem("stl"); A; index1(Temp0, 0); }
	else
	{       mnem("stl"); A; index1(Wptr, n_operand); }
	NL;
	POP;
}

/*   STNL:
 *   ----
 *    Ref: (T9000 ISM  Page 423)
 *     
 *     word'[Areg @ n] <- Breg
 *     
 *     Areg' <- Creg
 *     
 */
void STNL ()
{       int n = n_operand*BytesPerWord;
	if (big (n,15))
	{       mnem("addl"); A; T0; T0; NL; 
		mnem("stl"); B; index1(Temp0, 0); }
	else
	{       mnem("stl"); B; index1(Areg, n_operand); }
	NL;
	pop (2);
}

/*   OPR:
 *   ---
 *    Ref: (T9000 ISM  Page )
 *     
 *     
 *     
 *     
 *     
 */
void OPR ()
{       unimp ();
}


void CALL_KRN (const int Kep)
{
    if (o_kjumptable)
    {
	mnem("subl"); KT; dec(4*Kep); L; NL;
	mnem("jsr"); L; indirect(KLINK); dec(0); NL;
    }
    else switch (Kep)
    {
	case K_ALTWT: CALL_RTN ("$altwt"); break;
	case K_ENBC: CALL_RTN ("$enbc"); break;
	case K_DISC: CALL_RTN ("$disc"); break;
	case K_DISS: CALL_RTN ("$diss"); break;
	case K_TIN: CALL_RTN ("$tin"); break;
	case K_TALTWT: CALL_RTN ("$taltwt"); break;
	case K_ENBT: CALL_RTN ("$enbt"); break;
	case K_DIST: CALL_RTN ("$dist"); break;
	case K_REM: CALL_RTN ("$rem"); break;
	case K_DIV: CALL_RTN ("$div"); break;
	case K_IN: CALL_RTN ("$in"); break;
	case K_OUT: CALL_RTN ("$out"); break;
	case K_OUTBYTE: CALL_RTN ("$outbyte"); break;
	case K_OUTWORD: CALL_RTN ("$outword"); break;
	case K_STOPP: CALL_RTN ("$stopp"); break;
	case K_LDTIMER: CALL_RTN ("$ldtimer"); break;
	case K_MOVE: CALL_RTN ("$move"); break;
	case K_MOVE_ZERO: CALL_RTN ("$move"); break;
	case K_MOVE_NONZERO: CALL_RTN ("$move"); break;
	case K_FPSQRT: CALL_RTN ("$fpsqrt"); break;
	case K_RANGERR: CALL_RTN ("$rangerr"); break;
	case K_SETERR: CALL_RTN ("$seterr"); break;
    }
}

void GEN_TRAP (const int Reason)
{
    switch (o_checks)
    {
      case CH_NONE:
      {
	switch (Reason)
	{
	  case T_RANGE:
	  {
	    mnem("or"); Z; dec(Reason); P0; NL;
	    mnem("call_pal"); str("0xaa"); NL;
	    break;
	  }
	  default:
	    break;  /* assume software interrupt will trap to OS */
	}
	break;
      }
      case CH_SETFLAG:
      {
	SET_EFLAG; break;
      }
      case CH_TRAP:
      case CH_HALT:
      {
	int Kep;
	mnem("or"); Z; dec(Reason); P0; NL;                                      \
	switch (Reason)
	{
	  case T_RANGE:
	    Kep = K_RANGERR; break;
	  default:
	    Kep = K_SETERR; break;
	}
	CALL_KRN (Kep);
	break;
      }
    }
}
