/*
 * KROC ALPHA translator - Instructions concerned with processes
 *
 * $Source: /extra/play/cvs/kroc/src/target/alpha/f_proc.c,v $
 *
 * $Id: f_proc.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * ALPHA target only.
 */

static char f_proc_c_rcsid[] = "$Id: f_proc.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

#include "octran.h"

/*
 *  ENDP:
 *  ----
 *   Ref: (T9000 ISM  Page 276)
 *
 *     word'[Areg @ pp.Count] <- word[Areg @ pp.Count] - 1
 *     if (word'[Areg @ pp.Count] = 0)
 *     {
 *       Iptr' <- word[Areg @ pp.Iptrsucc]
 *       Wptr' <- Areg
 *     }
 *     else
 *       ... start next process
 */
void ENDP ()
{
	/* word'[Areg @ pp.Count] <- word[Areg @ pp.Count] - 1 */
	mnem("ldl"); T0; index1(Areg, 1); NL;
	mnem("subl"); T0; dec(1); T0; nl;
	mnem("stl"); T0; index1(Areg, 1); NL;

	/* if (word'[Areg @ pp.Count] = 0) */
	mnem("beq"); T0; f(1); nl;
	CALL_KRN (K_STOPP);  /* CALL_RTN("$scheduler") */
	lab(1); nl;

	mnem("ldl"); T0; index1(Areg, 0); nl;
	mnem("mov"); A; W; NL;
	mnem("jmp"); Z; indirect(Temp0); NL;

	istackp = 0;
	fstackp = 0;
	ishuff = 0;
	BREAK;
}

/*
 *  STARTP:
 *  ------
 *   Ref: (T9000 ISM  Page 418)
 *
 *     word'[Areg @ pw.Iptr] <- next .t instruction + Breg
 *     ... put process Areg onto the back of the queue.
 *     
 *     
 */
void STARTP ()
{
	/* word'[Areg @ pw.Iptr] <- next instruction + Breg */
	mnem("lda"); RA; f(4); COMMENT("get PC of next .t instruction"); NL;
lab(1); mnem("addl"); RA; B; RA; nl;
	mnem("stl"); RA; index1(Areg, -1); nl;

	/* ... put process Areg onto the back of the queue. */
	mnem("cmpeq"); FP; MIN; T0; nl;
	mnem("bne"); T0; f(2); nl;
	mnem("stl"); A; index1(Bptr, -2); nl;
	mnem("br"); Z; f(3); NL;
lab(2); mnem("mov"); A; FP; nl;
lab(3); mnem("mov"); A; BP; nl;
lab(4); nl;
	istackp = 0;
	fstackp = 0;
	ishuff = 0;
}

/*
 *  STOPP:
 *  -----
 *   Ref: (T9000 ISM  Page 425)
 *
 *      word'[Wptr @ pw.Iptr] <- next instruction
 *     
 *     
 *     
 */
void STOPP ()
{
	CALL_KRN(K_STOPP);
	istackp = 0;
	fstackp = 0;
	ishuff = 0;
}

/*
 *  STHF:
 *  ----
 *   Ref: (T800 ITT  Page 198)
 *
 *     HPBP' <- A
 *     Areg' <- B
 *     Breg' <- C
 *     
 */
void STHF ()
{       unimp ();
/*      mnem("mov"); A; FP; NL; */
	POP;
}

/*
 *  STLB:
 *  ----
 *   Ref: (T800 ITT  Page 201)
 *
 *     BP'   <- A
 *     Areg' <- B
 *     Breg' <- C
 *     
 */
void STLB ()
{       mnem("mov"); A; BP; NL;
	POP;
}

/*
 *  STLF:
 *  ----
 *   Ref: (T800 ITT  Page 202)
 *
 *     FP'   <- A
 *     Areg' <- B
 *     Breg' <- C
 *
 */
void STLF ()
{       mnem("mov"); A; FP; NL;
	POP;
}

/*
 *  RUNP:
 *  ----
 *   Ref: (T9000 ISM  Page 407)
 *
 *     ... put process Areg onto back of process list
 *     
 *     
 *     
 */
void RUNP ()
{
	/* ... put process Areg onto the back of the queue. */
	mnem("bic"); A; dec(3); A; NL;
	mnem("cmpeq"); FP; MIN; T0; nl;
	mnem("bne"); T0; f(1); nl;
	mnem("stl"); A; index1(Bptr, -2); nl;
	mnem("br"); Z; f(2); NL;
lab(1); mnem("mov"); A; FP; nl;
lab(2); mnem("mov"); A; BP; nl;

	istackp = 0;
	fstackp = 0;
	ishuff = 0;
}

/*
 *  SAVEH:
 *  -----
 *   Ref: (T800 ITT  Page 189)
 *
 *     
 *     
 *     
 *     
 */
void SAVEH ()
{       unimp ();
/*      mnem("stl"); BP; index1(Areg, 1); NL;   */
/*      mnem("stl"); FP; index1(Areg, 0); nl;   */
}

/*
 *  SAVEL:
 *  -----
 *   Ref: (T800 ITT  Page 190)
 *
 *     word'[Areg @ 1]  <- lpBP
 *     word'[Areg @ 0]  <- lpFP
 *     A' <- B
 *     B' <- C
 *     
 */
void SAVEL ()
{       mnem("stl"); BP; index1(Areg, 1); NL;
	mnem("stl"); FP; index1(Areg, 0); nl;
}

/*
 *  STHB:
 *  ----
 *   Ref: (T800 ITT  Page 198)
 *
 *     
 *     
 *     
 *     
 */
void STHB ()
{       unimp ();
/*      mnem("mov"); A; BP; NL; */
	POP;
}
