
!
! KROC ALPHA assembly-language initialization.
!
! $Source: /extra/play/cvs/kroc/src/target/alpha/occamentry.s,v $
!
! $Id: occamentry.s,v 1.1 1999/09/27 21:10:12 rivimey Exp $
!
! (C) Copyright 1996 M.D. Poole <M.D.Poole@ukc.ac.uk>
!                    et al.
! University of Kent at Canterbury
!
! This is the occam entry code and is called from the scheduler.
! This version sets up host stdin stdout and stderr as program parameters
!

/*{{{  define register names*/
#include <regdef.h>
#include "sched.h"
/*}}}  */

	.text
MAKENAME(occamentry_s_rcsid):
	.ascii  "$Id: occamentry.s,v 1.1 1999/09/27 21:10:12 rivimey Exp $\0"

	.globl  occamentry
	.ent    occamentry
occamentry:
/*{{{  only this fold depends on the main program parameter list*/
/*{{{  workspace*/
/*      if wsbytes > 0 then workspace is to be allocated on the stack
	and code cannot be executed from it.
	Otherwise we assume that $vectorspace points at the top of ws/
	bottom of vs of appropriate size.
*/
	ldl     T1,$wsbytes             #  zero implies ws in code
	beq     T1,spaceincode
spaceinstack:
	bis     sp,sp,Wptr
	ldl     T0,$vsbytes
	subl    Wptr,T0,Wptr
	bis     Wptr,Wptr,T2            #  bottom of VS, top of WS
	subl    Wptr,24,Wptr            #  for params of occam main proc
	subl    Wptr,T1,sp              #  move C stack below occam WS
	br      zero,setparams
spaceincode:
	lda     Wptr,$vectorspace       #  top of ws is bottom of vs
	lda     T2,$vectorspace         #  Vector space as pseudo-parameter
	subl    Wptr,24,Wptr            #  for params of occam main proc
/*}}}  */
	.globl setparams
setparams:
	stl     T2,16(Wptr)
	lda     T0,kbd_chan             #  stdin as pseudo-parameter
	stl     T0,4(Wptr)
	lda     T0,scr_chan             #  stdout as pseudo-parameter
	stl     T0,8(Wptr)
	lda     T0,err_chan             #  stderr as pseudo-parameter
	stl     T0,12(Wptr)

	lda     L,returnfromuser        #  occams code uses this
	stl     L,0(Wptr)               #  Carl: code needs this
	lda     pv,$entry_user
	jsr     ra,(pv),$entry_user     #  Run user program (should not change gp)
!       ------------------------
/*{{{  wind up*/
returnfromuser:
	ldgp   gp,0(ra)
	ldl    T0,$wsbytes
	beq    T0,finish
	addl   sp,T0,sp
	addl   sp,24,sp
	ldl    T0,$vsbytes
	addl   sp,T0,sp
/*}}}  */
/*}}}  */
/*{{{  call occam_exit -- will not return*/
finish:
	bis     zero,zero,P1
	bis     zero,zero,P0
	lda     pv,occam_exit
	jsr     ra,(pv),occam_exit
/*}}}  */
	.end    occamentry
