/*
 * KROC translator: 
 *
 * $Source: /extra/play/cvs/kroc/src/target/arm/arm-asm.c,v $
 *
 * $Id: arm-asm.c,v 1.1 1999/09/27 21:24:00 rivimey Exp $
 *
 * arm-asm.c:
 * (C) Copyright 1999 R. Ivimey-Cook <ruthc@sharra.demon.co.uk>
 *
 */

#include "asm.h"
#include "asm-utils.h"

static void Init(void)
{
}

static void Close(void)
{
}

static void Mnemonic(const char *mnemonic)
{
    SpaceTo(GetTabSize());
    Output(mnemonic);
}

static void Comment(const char *str)
{
    OutputTab();
    Output("; ");
    Output(str);
    NewLine();
}

static void GlobalFn(const char *name)
{
    SpaceTo(GetTabSize());
    Output("export");
    Output(name);
    NewLine();
    
    Output(name);
}

static void LocalFn(const char *name)
{
    Output(name);
}

static void StartofFile(void)
{
    Comment("This file is automatically generated by Octran");
    NewLine();
    Comment("");
    NewLine();
    Comment(GetCurrentFilename());
    NewLine();
}

static void EndofFile(void)
{
    NewLine();
    Mnemonic("end");
    NewLine();
}

static void ImportSym(const char *name)
{
    SpaceTo(GetTabSize());
    Output("import");
    OutputTab();
    Output(name);
    NewLine();
}

static void ExportSym(const char *name)
{
    SpaceTo(GetTabSize());
    Output("export");
    OutputTab();
    Output(name);
    NewLine();
}

static void ConstData(const int size, long value)
{
    SpaceTo(GetTabSize());
    switch(size)
    {
        case 1:
            Output("dcb");
            break;
        case 2:
            Output("dcw");
            break;
        case 4:
            Output("dcd");
            break;
        default:            
            break;
    }
    OutputTab();
    OutputF("0x%x\n", value);
}


AssemblerProcVec AsmARMASMProcs =
{
    Init,
    Close,
    Mnemonic,
    Comment,
    GlobalFn,
    LocalFn,
    StartofFile,
    EndofFile,
    ImportSym,
    ExportSym,
    ConstData,
};
