;;  KROC ALPHA assembly-language initialization.
;; 
;;  $Source: /extra/play/cvs/kroc/src/target/arm/occamentry.s,v $
;; 
;;  $Id: occamentry.s,v 1.1 1999/09/27 21:10:12 rivimey Exp $
;; 
;;  (C) Copyright 1996 M.D. Poole <M.D.Poole@ukc.ac.uk>
;;                     et al.
;;  University of Kent at Canterbury
;; 
;;  This is the occam entry code and is called from the scheduler.
;;  This version sets up host stdin stdout and stderr as program parameters
;; 

;{{{  define register names
;include <regdef.h>
;include "sched.h"
;}}}  

	CODE32
	AREA	|Occam$$Code|, CODE, READONLY
	
	DCB  "$Id: occamentry.s,v 1.1 1999/09/27 21:10:12 rivimey Exp $\0"

	EXPORT  occamentry
occamentry
;{{{  only this fold depends on the main program parameter list
;{{{  workspace
;      if wsbytes > 0 then workspace is to be allocated on the stack
; 	and code cannot be executed from it. 
; 	Otherwise we assume that $vectorspace points at the top of ws/
; 	bottom of vs of appropriate size.

	ldr	T1,=|$wsbytes|		;  zero implies ws in code
	ldr	T0, [T0]
	cmp	T1, #0
	beq	spaceincode
spaceinstack
	mov	Wptr, sp
	ldr	T0, =|$vsbytes|
	sub	Wptr,Wptr,T0
	mov	T2, Wptr		;  bottom of VS, top of WS
	sub	Wptr,Wptr,#24		;  for params of occam main proc
	sub	Wptr,T1,sp		;  move C stack below occam WS
	b	setparams
	
spaceincode
	ldr	Wptr, =|$vectorspace|	;  top of ws is bottom of vs
	ldr	Wptr, [Wptr]
	mov	T2, Wptr		;  Vector space as pseudo-parameter
	sub	Wptr,Wptr,#24		;  for params of occam main proc
	b	setparams
;}}}  
	EXPORT setparams
setparams
	str	T2, [Wptr, #16]
	ldr	T0, =kbd_chan		;  stdin as pseudo-parameter
	str	T0, [Wptr, #4]
	ldr	T0, =scr_chan		;  stdout as pseudo-parameter
	str	T0, [Wptr, #8]
	ldr	T0, =err_chan		;  stderr as pseudo-parameter
	str	T0, [Wptr, #12]

	ldr	T0, =returnfromuser	;  occams code uses this
	str	T0, [Wptr]		;  Carl: code needs this
	bl	|$entry_user|		;  Run user program (should not change gp)
	
;;        ------------------------
;{{{  wind up
returnfromuser
	ldr	T0,=|$wsbytes|
	ldr	T0, [T0]
	cmp	T0, #0
	beq	finish
	add	sp, sp, T0
	add	sp, sp, #24
	ldr	T0, =|$vsbytes|
	ldr	T0, [T0]
	add	sp, sp, T0
;}}}  
;}}}  
;{{{  call occam_exit -- will not return
finish
	b	occam_exit
;}}}  
	END
