/*
 * KROC SPARC translator: Instructions involved in ALT constructs and timeouts.
 *
 * $Source: /extra/play/cvs/kroc/src/target/sparc/f_alt.c,v $
 *
 * $Id: f_alt.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * SPARC target only.
 */

static char f_alt_c_rcsid[] = "$Id: f_alt.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $";

#include "octran.h"

void ALT ()
{	mnem("add"); MIN; dec(Enabling_d); T0; NL;
	mnem("st"); T0; sindex(Wptr, pw_State); nl;
}

void ALTWT ()
{	mnem("mov"); dec(NoneSelected_o); T0; NL;
	mnem("st"); T0; sindex(Wptr, pw_Temp); nl;
	mnem("ld"); sindex(Wptr, pw_State); T0; nl;
	mnem("add"); MIN; dec(Ready_d); T1; nl;
	mnem("cmp"); T1; T0; nl;
	mnem("be"); f(1); nl;
	mnem("add"); MIN; dec(Waiting_d); T1; DELAY; nl;
	mnem("st"); T1; sindex(Wptr, pw_State); nl;
	extcall(X_STOPP); nl;
	ADJUST; nl;
lab(1);	nl;
	istackp = 0;
	ishuff = 0;
}

void ALTEND ()
{	mnem("ld"); sindex(Wptr, pw_Temp); T0; NL;
	mnem("call"); f(1); COMMENT("get PC"); nl;	/* 0 */
	mnem("add"); L; T0; L; DELAY; nl;		/* 1 */
lab(1);	mnem("jmp"); L; offset(4); nl;			/* 2 */
	mnem("nop"); nl;				/* 3 */
	BREAK;						/* 4 */
	istackp = 0;
	ishuff = 0;
}

void ENBC ()
{	mnem("tst"); A; NL;
	mnem("be"); f(1); nl;
	mnem("or"); W; dec(1); T1; DELAY; nl;
	mnem("ld"); sindex(Breg, 0); T0; nl;
	mnem("cmp"); T1; T0; nl;
	mnem("be"); f(1); nl;
	mnem("cmp"); T0; MIN; DELAY; nl;
	mnem("be,a"); f(1); nl;
	mnem("st"); T1; sindex(Breg, 0); ANNUL; nl;
	mnem("add"); MIN; dec(Ready_d); T0; nl;
	mnem("st"); T0; sindex(Wptr, pw_State); nl;
lab(1);	mnem("mov"); A; B; nl;
	ishuff += 1;
	POP;
}

void ENBS ()
{	mnem("tst"); A; NL;
	mnem("be"); f(1); nl;
	mnem("add"); MIN; dec(Ready_d); T0; DELAY; nl;
	mnem("st"); T0; sindex(Wptr, pw_State); nl;
lab(1);	nl;
	ishuff += 1;
}

void DISC ()
{	mnem("tst"); B; NL;
	mnem("be"); f(1); nl;
	mnem("mov"); FALSE; B; DELAY; nl;
	mnem("ld"); sindex(Creg, 0); T0; nl;
	mnem("or"); W; dec(1); T1; nl;
	mnem("cmp"); T1; T0; nl;
	mnem("be,a"); f(1); nl;
	mnem("st"); MIN; sindex(Creg, 0); ANNUL; nl;
	mnem("cmp"); T0; MIN; nl;
	mnem("be"); f(1); nl;
	mnem("ld"); sindex(Wptr, pw_Temp); T0; DELAY; nl;
	mnem("cmp"); T0; dec(NoneSelected_o); nl;
	mnem("bne"); f(1); nl;
	mnem("nop"); nl;			/* ??? */
	mnem("st"); A; sindex(Wptr, pw_Temp); nl;
	mnem("mov"); TRUE; B; nl;
lab(1);	mnem("mov"); B; C; nl;
	ishuff = 1;
	pop (2);
}

void DISS ()
{	mnem("tst"); B; NL;
	mnem("be"); f(1); nl;
	mnem("nop"); nl;
	mnem("ld"); sindex(Wptr, pw_Temp); T0; nl;
	mnem("cmp"); T0; dec(NoneSelected_o); nl;
	mnem("bne,a"); f(1); nl;
	mnem("mov"); FALSE; B; annul("false"); nl;
	mnem("mov"); TRUE; B; COMMENT("true"); nl;
	mnem("st"); A; sindex(Wptr, pw_Temp); nl;
lab(1);	nl;
	ishuff += 1;
	POP;
}

/*	Timer stuff	*/

void TIN ()
{	shufflecount += shuffle (istackp, 1);	/* requires ONE item on stack */
	extcall(X_TIN); NL;
	ADJUST; nl;
	istackp = 0;
}

void TALT ()
{	if (o_real64)			/* hardly worth it */
	{	mnem("add"); MIN; dec(TimeNotSet_d); T0; NL;
		mnem("add"); MIN; dec(Enabling_d); T1; nl;
		mnem("std"); T0; sindex(Wptr, pw_TLink); nl;
	}
	else
	{	mnem("add"); MIN; dec(Enabling_d); T0; NL;
		mnem("st"); T0; sindex(Wptr, pw_State); nl;
		mnem("add"); MIN; dec(TimeNotSet_d); T0; nl;
		mnem("st"); T0; sindex(Wptr, pw_TLink); nl;
	}
}

void TALTWT ()
{	extcall(X_TALTWT); NL;
	ADJUST; nl;
	istackp = 0;
	ishuff = 0;
}

void ENBT ()
{	mnem("tst"); A; NL;
	mnem("be"); f(2); nl;
	mnem("add"); MIN; dec(TimeNotSet_d); T0; DELAY; nl;
	mnem("ld"); sindex(Wptr, pw_TLink); T1; nl;
	mnem("cmp"); T1; T0; nl;
	mnem("bne,a"); f(1); nl;
	mnem("ld"); sindex(Wptr, pw_Time); T0; ANNUL; nl;
	mnem("add"); MIN; dec(TimeSet_d); T0; nl;
	mnem("st"); T0; sindex(Wptr, pw_TLink); nl;
	mnem("ba"); f(2); nl;
	mnem("st"); B; sindex(Wptr, pw_Time); DELAY; nl;

lab(1);	mnem("cmp"); B; T0; nl;		/* was T0 - B positive */
	mnem("bneg,a"); f(2); nl;
	mnem("st"); B; sindex(Wptr, pw_Time); ANNUL; nl;
lab(2);	mnem("mov"); A; B; nl;
	ishuff += 1;
	POP;
}

void DIST ()
{	extcall(X_DIST); NL;
	ADJUST; nl;
	ishuff += 1;
	pop (2);
}
