/*
 * KROC SPARC translator: Arithmetic and logical instructions
 *
 * $Source: /extra/play/cvs/kroc/src/target/sparc/f_arith.c,v $
 *
 * $Id: f_arith.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * SPARC target only.
 */

static char f_arith_c_rcsid[] = "$Id: f_arith.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $";

#include "octran.h"
#include <string.h>

void DIFF ()
{	mnem("sub"); B; A; B; NL;
	POP;
}

void ADD ()
{	mnem("addcc"); B; A; B; NL;
	CHECK;
	if (strstr(b_comment, " check for replicator overflow") != NULL)
		pop (2);
	else
		POP;
}

void PROD ()
{	if (o_hardware)
	{	mnem("smul"); B; A; B; NL; }
	else
	{	mnem("mov"); B; P0; NL;
		extcall(X_MUL); nl;
		mnem("mov"); A; P1; DELAY; nl;
		check (C_NE, T_OFLOW);
		mnem("mov"); P0; B; nl;
	}
	POP;
}

void SUB ()
{	mnem("subcc"); B; A; B; NL;
	CHECK;
	POP;
}

void REM ()
{	if (o_hardware)
	{	mnem("sra"); B; dec(BitsPerWord-1); T0; COMMENT("%y := sign(B)"); NL;
		mnem("mov"); T0; Y; nl;
		mnem("sdivcc"); B; A; T0; nl;
		CHECK;
		mnem("smul"); T0; A; T0; nl;
		mnem("sub"); B; T0; B; nl;
	}
	else
	{	mnem("mov"); B; P0; NL;
		extcall(X_REM); nl;
		mnem("mov"); A; P1; DELAY; nl;
		/* don't know how to check overflow */
		mnem("mov"); P0; B; nl;
	}
	POP;
}

void DIV ()
{	if (o_hardware)
	{	mnem("sra"); B; dec(BitsPerWord-1); T0; COMMENT("%y := sign(B)"); NL;
		mnem("mov"); T0; Y; nl;
		mnem("sdivcc"); B; A; B; nl;
		CHECK;
	}
	else
	{	mnem("mov"); B; P0; NL;
		extcall(X_DIV); nl;
		mnem("mov"); A; P1; DELAY; nl;
		/* don't know how to check overflow */
		mnem("mov"); P0; B; nl;
	}
	POP;
}

void NOT ()
{	mnem("not"); A; NL;
}

void XOR ()
{	mnem("xor"); B; A; B; NL;
	POP;
}

void SHR ()
{	mnem("cmp"); A; dec(BitsPerWord); COMMENT("excessive shift"); NL;
	mnem("bgeu,a"); f(1); nl;
	mnem("clr"); B; ANNUL; nl;
	mnem("srl"); B; A; B; nl;
lab(1);	nl;
	POP;
}

void SHL ()
{	mnem("cmp"); A; dec(BitsPerWord); COMMENT("excessive shift"); NL;
	mnem("bgeu,a"); f(1); nl;
	mnem("clr"); B; ANNUL; nl;
	mnem("sll"); B; A; B; nl;
lab(1);	nl;
	POP;
}

void AND ()
{	mnem("and"); B; A; B; NL;
	POP;
}

void OR ()
{	mnem("or"); B; A; B; NL;
	POP;
}

void SUM ()
{	mnem("add"); B; A; B; NL;
	POP;
}

void MUL ()
{	if (o_hardware)
	{	mnem("smul"); B; A; B; NL;
		if (o_checks)
		{	mnem("mov"); Y; T0; COMMENT("%y = sign(B)?"); nl;
			mnem("addcc"); B; B; Z; nl;
			mnem("addxcc"); T0, Z; Z; nl;
			check (C_NE, T_OFLOW);
		}
		else
		{	dummy("checks off"); nl; }
	}
	else
	{	mnem("mov"); B; P0; NL;
		extcall(X_MUL); nl;
		mnem("mov"); A; P1; DELAY; nl;
		check (C_NE, T_OFLOW);
		mnem("mov"); P0; B; nl;
	}
	POP;
}
