/*
 * KROC translator: Miscellaneous "operate" instructions.
 *
 * $Source: /extra/play/cvs/kroc/src/target/sparc/f_etc.c,v $
 *
 * $Id: f_etc.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * SPARC target only.
 */

static char f_etc_c_rcsid[] = "$Id: f_etc.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $";

#include "octran.h"
#include <string.h>

void REV ()
{	mnem("mov"); A; T0; NL;
	mnem("mov"); B; A; nl;
	mnem("mov"); T0; B; nl;
}

void LB ()
{	if (o_reverse)
	{	mnem("xor"); A; dec(ByteSelectMask); A; NL; }
	mnem("ldub"); sindex(Areg, 0); A; NL;
}

void BSUB ()
{	mnem("add"); B; A; B; NL;
	POP;
}

void GCALL ()			/* UNadjusted PC used internally */
{	mnem("jmpl"); A; A; NL;	/* value in A not used by occam */
/*	mnem("inc"); dec(2*BytesPerWord); A; delay("adjust"); nl;	*/
	mnem("nop"); nl;
	istackp = 0;
}

void GT ()
{	mnem("cmp"); B; A;
	if (o_opt)
	{	COMMENT ("remember GT");
		NL;
		cond = C_GT;
	}
	else
	{	NL;
		mnem("bg,a"); f(1); nl;
		mnem("mov"); TRUE; B; annul("true"); nl;
		mnem("mov"); FALSE; B; COMMENT("false"); nl;
	lab(1);	nl;
	}
	POP;
}

void WSUB ()
{	mnem("sll"); B; dec(2); B; NL;	/* CWG p.18, NOT p.127! */
	mnem("add"); B; A; B; nl;
	POP;
}

void RESETCH ()
{	mnem("ld"); sindex(Areg, 0); T0; NL;
	mnem("st"); MIN; sindex(Areg, 0); nl;
	mnem("mov"); T0; A; nl;
}

void CSUB0 ()			/* what if checks are off? */
{	mnem("cmp"); B; A; NL;
	check (C_GEU, T_RANGE);
	if ((strcmp(b_comment, " throw the result away") == 0) ||
	    (strcmp(b_comment, " alignment check") == 0))
		pop (2);
	else
	{	ishuff += 1;
		POP;
	}
}

/*	NORM now in "f_long.c"	*/

void LDPI ()
{	if (o_label && l_operand[0] != 0)
	{	mnem("set"); str(l_operand); offset(2); A; NL;
		mnem("call"); str(l_right); COMMENT("get PC"); nl;
		mnem("add"); A; L; A; DELAY; nl;		/* 1 */
								/* 2 */
		l_operand[0] = 0;
	}
	else
	{	mnem("call"); f(1); COMMENT("get PC"); NL;	/* 0 */
		mnem("add"); A; L; A; DELAY; nl;		/* 1 */
	lab(1);	mnem("inc"); dec(3*BytesPerWord); A; nl;	/* 2 */
								/* 3 */
	}
}

void XDBLE ()
{	PUSH;
	mnem("mov"); B; A; NL;
	mnem("sra"); B; dec(BitsPerWord-1); B; COMMENT("B := sign(B)"); nl;
}

void LDPRI ()			/* could use a bit in STATUS */
{	PUSH;
	mnem("mov"); dec(1); A; COMMENT("low priority only"); NL;
/*	mnem("srl"); STATUS; dec(2); A; NL;	*/
}

void RET ()			/* unadjusted PC used internally */
{	int i, temp;
	mnem("ld"); sindex(Wptr, 0); L; NL;
	mnem("retl"); nl;
	mnem("inc"); dec(4*BytesPerWord); W; DELAY; nl;
	if (proctab[stcount].S_PTYPE == P_FUNCTION)
	{	proctab[stcount].S_ISTACK = istackp;
		proctab[stcount].S_FSTACK = fstackp;
		proctab[stcount].S_ISHUFF = ishuff;
		temp = 0;
		for (i = fstackp; i > 0; --i)	/* at most one returned (ORTMS p.10) */
			temp = (temp << 1) | ftype[i];
		proctab[stcount].S_FTYPES = temp;
	}
	else
	{	proctab[stcount].S_ISTACK = 0;
		proctab[stcount].S_FSTACK = 0;
		proctab[stcount].S_ISHUFF = 0;
		proctab[stcount].S_FTYPES = 0;	/* unnecessary */
	}
	if (o_verbose)
	{	fprintf (stderr, "\n... End of %s %s %s\n",
			proctab[stcount].label, ptype[proctab[stcount].S_PTYPE],
			proctab[stcount].proc);
		fprintf (stderr, "    istack = %d, fstack = [", istackp);
		for (i = fstackp; i > 0; --i)
			fputc ((ftype[i] == F_D) ? 'D' : 'S', stderr);
		fputc (']', stderr);
		where ();
	}
	istackp = 0;
	fstackp = 0;
	ishuff = 0;
	BREAK;
}

void LEND (void)
{	if (o_resched)
	{	if (o_label && l_operand[0] != 0)
		{	if (o_real64)
			{	mnem("ldd"); sindex(Breg, 0); T0; NL;
				mnem("deccc"); T1; COMMENT("--count"); nl;
				mnem("bleu"); str(l_left); nl;	/* unsigned (CWG p.17) */
				mnem("inc"); T0; delay("++index"); nl;
				mnem("ld"); vindex("sync"); T2; nl;
				mnem("tst"); T2; nl;
				mnem("be"); str(l_right); nl;
				mnem("std"); T0; sindex(Breg, 0); DELAY; nl;
			}
			else /* no double-word alignment */
			{	mnem("ld"); sindex(Breg, le_Count); T0; nl;
				mnem("deccc"); T0; COMMENT("--count"); nl;
				mnem("bleu"); str(l_left); nl;
				mnem("st"); T0; sindex(Breg, le_Count); DELAY; nl;
				mnem("ld"); sindex(Breg, le_Index); T0; nl;
				mnem("inc"); T0; COMMENT("++index"); nl;
				mnem("ld"); vindex("sync"); T1; nl;
				mnem("tst"); T1; nl;
				mnem("be"); str(l_right); nl;
				mnem("st"); T0; sindex(Breg, le_Index); DELAY; nl;
			}
			extcall(X_RESCHED); nl;
			ADJUST; nl;
			mnema("ba"); str(l_right); nl;
			BREAK;
			l_operand[0] = 0;
		}
		else /* no label-difference optimization */
		{	if (o_real64)
			{	mnem("ldd"); sindex(Breg, 0); T0; NL;
				mnem("deccc"); T1; COMMENT("--count"); nl;
				mnem("bleu"); f(3); nl;
				mnem("inc"); T0; delay("++index"); nl;
				mnem("ld"); vindex("sync"); T2; nl;
				mnem("tst"); T2; nl;
				mnem("bne"); f(2); nl;
				mnem("std"); T0; sindex(Breg, 0); DELAY; nl;
			}
			else
			{	mnem("ld"); sindex(Breg, le_Count); T0; NL;
				mnem("deccc"); T0; COMMENT("--count"); nl;
				mnem("bleu"); f(3); nl;
				mnem("st"); T0; sindex(Breg, le_Count); DELAY; nl;
				mnem("ld"); sindex(Breg, le_Index); T0; nl;
				mnem("inc"); T0; COMMENT("++index"); nl;
				mnem("ld"); vindex("sync"); T1; nl;
				mnem("tst"); T1; nl;
				mnem("bne"); f(2); nl;
				mnem("st"); T0; sindex(Breg, le_Index); DELAY; nl;
			}
			mnem("call"); f(1); COMMENT("get PC"); nl;		/* 0 */
			mnem("sub"); L; A; L; DELAY; nl;			/* 1 */
		lab(1);	mnem("jmp"); L; offset(7); nl;				/* 2 */
			mnem("nop"); nl;					/* 3 */
			BREAK;
		lab(2);	mnem("dec"); dec(2*BytesPerWord); A; nl;		/* 4 */
			extcall(X_RESCHED); nl;					/* 5 */	/* 0 */
			mnem("sub"); L; A; L; delay("fake return address"); nl;	/* 6 */	/* 1 */
			BREAK;							/* 7 */	/* 2 */
		lab(3);	nl;
		}
	}
	else /* no rescheduling */
	{	if (o_label && l_operand[0] != 0)
		{	if (o_real64)
			{	mnem("ldd"); sindex(Breg, 0); T0; NL;
				mnem("inc"); T0; COMMENT("++index"); nl;
				mnem("deccc"); T1; COMMENT("--count"); nl;
				mnema("bgtu"); str(l_right); nl;
				mnem("std"); T0; sindex(Breg, 0); ANNUL; nl;
			}
			else
			{	mnem("ld"); sindex(Breg, le_Index); T0; NL;
				mnem("ld"); sindex(Breg, le_Count); T1; nl;
				mnem("inc"); T0; COMMENT("++index"); nl;
				mnem("deccc"); T1; COMMENT("--count"); nl;
				mnem("st"); T0; sindex(Breg, le_Index); nl;
				mnema("bgtu"); str(l_right); nl;
				mnem("st"); T1; sindex(Breg, le_Count); ANNUL; nl;
			}
			BREAK;
			l_operand[0] = 0;
		}
		else
		{	if (o_real64)
			{	mnem("ldd"); sindex(Breg, 0); T0; NL;
				mnem("deccc"); T1; COMMENT("--count"); nl;
				mnem("bleu"); f(2); nl;
				mnem("inc"); T0; delay("++index"); nl;
				mnem("call"); f(1); COMMENT("get PC"); nl;
				mnem("sub"); L; A; L; DELAY; nl;
			lab(1);	mnem("jmp"); L; offset(4); nl;
				mnem("std"); T0; sindex(Breg, 0); DELAY; nl;
			}
			else
			{	mnem("ld"); sindex(Breg, le_Count); T0; NL;
				mnem("deccc"); T0; COMMENT("--count"); nl;
				mnem("bleu"); f(2); nl;
				mnem("st"); T0; sindex(Breg, le_Count); DELAY; nl;
				mnem("ld"); sindex(Breg, le_Index); T0; nl;
				mnem("inc"); T0; COMMENT("++index"); nl;
				mnem("call"); f(1); COMMENT("get PC"); nl;		/* 0 */
				mnem("sub"); L; A; L; DELAY; nl;			/* 1 */
			lab(1);	mnem("jmp"); L; offset(4); nl;				/* 2 */
				mnem("st"); T0; sindex(Breg, le_Index); DELAY; nl;	/* 3 */
											/* 4 */
			}
			BREAK;
			lab(2);	nl;
		}
	}
	istackp = 0;
	fstackp = 0;
	ishuff = 0;
}

void LDTIMER ()
{	PUSH;
	extcall(o_time ? X_RTIME : X_UTIME); NL;
	mnem("nop"); nl;
	mnem("mov"); P0; A; nl;
}

void STTIMER ()
{	unimp ();		/* don't understand */
	POP;
}

void TESTPRANAL ()
{	PUSH;
	mnem("mov"); FALSE; A; NL;
}

void BCNT ()
{	mnem("sll"); A; dec(2); A; NL;
}

void XWORD ()
{	mnem("cmp"); A; B; NL;
	mnem("bg"); f(1); nl;
	mnem("sll"); A; dec(1); T0; DELAY; nl;
	mnem("sub"); B; T0; B; nl;
lab(1);	nl;
	POP;
}

void SB ()
{	if (o_reverse)
	{	mnem("xor"); A; dec(ByteSelectMask); A; NL; }
	mnem("stb"); B; sindex(Areg, 0); NL;
	pop (2);
}

void GAJW ()
{	mnem("mov"); A; T0; NL;
	mnem("mov"); W; A; nl;
	mnem("mov"); T0; W; nl;
	if (istackp > 1)		/* kludge */
	{	mnem("dec"); dec(8); B; COMMENT("adjust return for KERNEL.RUN"); nl; }
}

void WCNT ()
{	PUSH;
	mnem("sra"); B; dec(2); A; NL;
	mnem("and"); B; dec(3); B; nl;
}

void MINT ()
{	PUSH;
	mnem("mov"); MIN; A; NL;
}

void MOVE ()			/* A >= 0 (CWG p.21) */
{	if (o_reverse)
	{	extcall(X_MOVE); NL;
		ADJUST; nl;
	}
	else /* or perhaps not */
	{	mnem("ba,a"); f(2); NL;
	lab(1);	mnem("stb"); T0; index2(Breg, Areg); nl;
	lab(2);	mnem("deccc"); A; nl;
		mnem("bge,a"); b(1); nl;
		mnem("ldub"); index2(Creg, Areg); T0; ANNUL; nl;
	}
	istackp = 0;
	ishuff = 0;
}

void CSNGL ()			/* what if checks are off? */
{	mnem("addcc"); A; A; Z; NL;
/*	mnem("subxcc"); Z; Z; T0; nl;	*/
/*	mnem("cmp"); T0; B; nl;		*/
	mnem("addxcc"); B; Z; B; nl;
	check (C_NE, T_RANGE);
	mnem("mov"); A; B; nl;
	POP;
}

void CCNT1 ()			/* what if checks are off? */
{	mnem("sub"); B; dec(1); T0; NL;
	mnem("cmp"); T0; A; nl;
	check (C_GEU, T_RANGE);
	if (strcmp(b_comment, " throw the result away") == 0)
	/*	|| strcmp(b_comment, " alignment check") == 0	*/
		pop (2);
	else
	{	ishuff += 1;
		POP;
	}
}

void CWORD ()			/* what if checks are off? */
{	mnem("add"); A; B; T0; NL;
	mnem("sll"); A; dec(1); A; nl;
	mnem("cmp"); T0; A; nl;
	check (C_GEU, T_RANGE);
	POP;
}
