/*
 * KROC SPARC translator: Long arithmetic instructions.
 *
 * $Source: /extra/play/cvs/kroc/src/target/sparc/f_long.c,v $
 *
 * $Id: f_long.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * SPARC target only.
 */

static char f_long_c_rcsid[] = "$Id: f_long.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $";

#include "octran.h"

void LADD ()
{	mnem("sll"); C; dec(BitsPerWord-1); C; COMMENT("msb := lsb"); NL;
	mnem("addcc"); C; C; Z; COMMENT("carry := msb"); nl;
	mnem("addxcc"); B; A; C; nl;
	CHECK;
	pop (2);
}

void LDIV ()			/* o_hardware? */
{	if (o_checks)
	{	mnem("cmp"); C; A; NL;
		check (C_GEU, T_OFLOW);
	}
	mnem("mov"); C; Y; NL;
	mnem("udiv"); B; A; T0; nl;
	mnem("umul"); T0; A; A; nl;
	mnem("sub"); B; A; C; nl;
	mnem("mov"); T0; B; nl;
	ishuff = 1;
	POP;
}

void LMUL ()
{	if (o_hardware)
	{	mnem("umul"); B; A; B; NL;
		mnem("mov"); Y; T0; nl;
		mnem("addcc"); B; C; B; nl;
	}
	else
	{	mnem("mov"); A; P0; NL;
		extcall(X_UMUL); nl;
		mnem("mov"); B; P1; DELAY; nl;
		mnem("addcc"); P0; C; B; nl;
	}
	mnem("addx"); T0; dec(0); C; COMMENT("carry"); nl;
	ishuff = 1;
	POP;
}

void LSHR ()
{	mnem("tst"); A; COMMENT("zero shift"); NL;
	mnem("be"); f(2); nl;
	mnem("cmp"); A; dec(BitsPerWord*2); delay("excessive shift"); nl;
	mnem("bgeu,a"); f(1); nl;
	mnem("clr"); B; ANNUL; nl;
	mnem("cmp"); A; dec(BitsPerWord); COMMENT("long shift"); nl;
/*	mnem("be,a"); f(1); nl;		*/
/*	mnem("mov"); C; B; ANNUL; nl;	*/
	mnem("bge,a"); f(1); nl;
	mnem("srl"); C; A; B; ANNUL; nl;
	mnem("mov"); C; T0; COMMENT("short shift"); nl;
	mnem("srl"); B; A; B; nl;
	mnem("srl"); C; A; C; nl;
	mnem("neg"); A; nl;
	mnem("sll"); T0; A; T0; nl;
	mnem("ba"); f(2); nl;
	mnem("or"); B; T0; B; DELAY; nl;
lab(1);	mnem("clr"); C; nl;
lab(2);	nl;
	ishuff = 1;
	POP;
}

void LSHL ()
{	mnem("tst"); A; COMMENT("zero shift"); NL;
	mnem("be"); f(2); nl;
	mnem("cmp"); A; dec(BitsPerWord*2); delay("excessive shift"); nl;
	mnem("bgeu,a"); f(1); nl;
	mnem("clr"); C; ANNUL; nl;
	mnem("cmp"); A; dec(BitsPerWord); COMMENT("long shift"); nl;
/*	mnem("be,a"); f(1); nl;		*/
/*	mnem("mov"); B; C; ANNUL; nl;	*/
	mnem("bge,a"); f(1); nl;
	mnem("sll"); B; A; C; ANNUL; nl;
	mnem("mov"); B; T0; COMMENT("short shift"); nl;
	mnem("sll"); C; A; C; nl;
	mnem("sll"); B; A; B; nl;
	mnem("neg"); A; nl;
	mnem("srl"); T0; A; T0; nl;
	mnem("ba"); f(2); nl;
	mnem("or"); C; T0; C; DELAY; nl;
lab(1);	mnem("clr"); B; nl;
lab(2);	nl;
	ishuff = 1;
	POP;
}

void LSUM ()
{	mnem("sll"); C; dec(BitsPerWord-1); C; COMMENT("msb := lsb"); NL;
	mnem("addcc"); C; C; Z; COMMENT("carry := msb"); nl;
	mnem("addxcc"); B; A; B; nl;
	mnem("addx"); Z; Z; C; COMMENT("carry"); nl;
	ishuff = 1;
	POP;
}

void LSUB ()
{	mnem("sll"); C; dec(BitsPerWord-1); C; COMMENT("msb := lsb"); NL;
	mnem("addcc"); C; C; Z; COMMENT("carry := msb"); nl;
	mnem("subxcc"); B; A; C; nl;
	CHECK;
	pop (2);
}

void LDIFF ()
{	mnem("sll"); C; dec(BitsPerWord-1); C; COMMENT("msb := lsb"); NL;
	mnem("addcc"); C; C; Z; COMMENT("carry := msb"); nl;
	mnem("subxcc"); B; A; B; nl;
	mnem("addx"); Z; Z; C; COMMENT("carry"); nl;
	ishuff = 1;
	POP;
}

void NORM ()
{	PUSH;
	mnem("mov"); B; A; NL;
	mnem("orcc"); C; Z; B; nl;
	mnem("bneg"); f(2); COMMENT("already normalized"); nl;
	mnem("clr"); C; DELAY; nl;
	mnem("orcc"); A; B; Z; nl;
	mnem("beq,a"); f(2); COMMENT("special case"); nl;
	mnem("mov"); dec(BitsPerWord*2); C; ANNUL; nl;
lab(1);	mnem("addcc"); A; A; A; nl;
	mnem("addxcc"); B; B; B; nl;
	mnem("bpos"); b(1); nl;
	mnem("inc"); C; DELAY; nl;
lab(2);	nl;
}
