/*
 * KROC SPARC translator: Two-Dimensional block move instructions
 *
 * $Source: /extra/play/cvs/kroc/src/target/sparc/f_move2d.c,v $
 *
 * $Id: f_move2d.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * SPARC target only.
 */

static char f_move2d_c_rcsid[] = "$Id: f_move2d.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $";

#include "octran.h"

void MOVE2DINIT ()		/* (CWG p.95) */
{	mnem("mov"); A; G1; COMMENT("length"); NL;
	mnem("mov"); B; G2; COMMENT("destination stride"); nl;
	mnem("mov"); C; G3; COMMENT("source stride"); nl;
	istackp = 0;
	ishuff = 0;
}

void MOVE2DALL ()		/* A >= 0 (CWG p.80) */
{	if (o_reverse)
	{	mnem("ba"); f(2); NL;
		mnem("mov"); A; T2; DELAY; nl;
	lab(1);	extcall(X_MOVE); nl;	/* A bytes from [C] to [B] */
		ADJUST; nl;
		mnem("add"); C; G3; C; COMMENT("source address"); nl;
		mnem("add"); B; G2; B; COMMENT("destination address"); nl;
	lab(2);	mnem("deccc"); G1; nl;
		mnem("bge,a"); b(1); nl;
		mnem("mov"); T2; A; annul("width"); nl;
	}
	else	/* different registers make it messy to share */
	{	mnem("ba,a"); f(3); NL;
	lab(1);	mnem("stb"); T1; index2(Breg, Temp); nl;
	lab(2);	mnem("deccc"); T0; nl;
		mnem("bge,a"); b(1); nl;
		mnem("ldub"); index2(Creg, Temp); T1; ANNUL; nl;
		mnem("add"); C; G3; C; COMMENT("source address"); nl;
		mnem("add"); B; G2; B; COMMENT("destination address"); nl;
	lab(3);	mnem("deccc"); G1; nl;
		mnem("bge,a"); b(2); nl;
		mnem("mov"); A; T0; annul("width"); nl;
	}
	istackp = 0;
	ishuff = 0;
}

void MOVE2DNONZERO ()
{	if (o_reverse)
	{	mnem("ba,a"); f(3); NL;
	lab(1);	mnem("btog"); dec(ByteSelectMask); T0; nl;
		mnem("ldub"); sindex(Temp, 0); T1; nl;
		mnem("tst"); T1; nl;
		mnem("be"); f(2); nl;
		mnem("add"); B; T2; T0; DELAY; nl;	/* wasted when branch taken */
		mnem("btog"); dec(ByteSelectMask); T0; nl;
		mnem("stb"); T1; sindex(Temp, 0); nl;
	lab(2);	mnem("deccc"); T2; nl;
		mnem("bge,a"); b(1); nl;
		mnem("add"); C; T2; T0; ANNUL; nl;
		mnem("add"); C; G3; C; COMMENT("source address"); nl;
		mnem("add"); B; G2; B; COMMENT("destination address"); nl;
	lab(3);	mnem("deccc"); G1; nl;
		mnem("bge,a"); b(2); nl;
		mnem("mov"); A; T2; annul("width"); nl;
	}
	else
	{	mnem("ba,a"); f(3); NL;
	lab(1);	mnem("tst"); T1; nl;
		mnem("bne,a"); f(2); nl;
		mnem("stb"); T1; index2(Breg, Temp); ANNUL; nl;
	lab(2);	mnem("deccc"); T0; nl;
		mnem("bge,a"); b(1); nl;
		mnem("ldub"); index2(Creg, Temp); T1; ANNUL; nl;
		mnem("add"); C; G3; C; COMMENT("source address"); nl;
		mnem("add"); B; G2; B; COMMENT("destination address"); nl;
	lab(3);	mnem("deccc"); G1; nl;
		mnem("bge,a"); b(2); nl;
		mnem("mov"); A; T0; annul("width"); nl;
	}
	istackp = 0;
	ishuff = 0;
}

void MOVE2DZERO ()
{	if (o_reverse)
	{	mnem("ba,a"); f(3); NL;
	lab(1);	mnem("btog"); dec(ByteSelectMask); T0; nl;
		mnem("ldub"); sindex(Temp, 0); T1; nl;
		mnem("tst"); T1; nl;
		mnem("bne"); f(2); nl;
		mnem("add"); B; T2; T0; DELAY; nl;
		mnem("btog"); dec(ByteSelectMask); T0; nl;
		mnem("stb"); T1; sindex(Temp, 0); nl;	/* clrb */
	lab(2);	mnem("deccc"); T2; nl;
		mnem("bge,a"); b(1); nl;
		mnem("add"); C; T2; T0; ANNUL; nl;
		mnem("add"); C; G3; C; COMMENT("source address"); nl;
		mnem("add"); B; G2; B; COMMENT("destination address"); nl;
	lab(3);	mnem("deccc"); G1; nl;
		mnem("bge,a"); b(2); nl;
		mnem("mov"); A; T2; annul("width"); nl;
	}
	else
	{	mnem("ba,a"); f(3); NL;
	lab(1);	mnem("tst"); T1; nl;
		mnem("be,a"); f(2); nl;
		mnem("stb"); T1; index2(Breg, Temp); ANNUL; nl;
	lab(2);	mnem("deccc"); T0; nl;
		mnem("bge,a"); b(1); nl;
		mnem("ldub"); index2(Creg, Temp); T1; ANNUL; nl;
		mnem("add"); C; G3; C; COMMENT("source address"); nl;
		mnem("add"); B; G2; B; COMMENT("destination address"); nl;
	lab(3);	mnem("deccc"); G1; nl;
		mnem("bge,a"); b(2); nl;
		mnem("mov"); A; T0; annul("width"); nl;
	}
	istackp = 0;
	ishuff = 0;
}
