/*
 * KROC SPARC translator: Special instructions for the T800.
 *
 * $Source: /extra/play/cvs/kroc/src/target/sparc/f_t800.c,v $
 *
 * $Id: f_t800.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * SPARC target only.
 */

static char f_t800_c_rcsid[] = "$Id: f_t800.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $";

#include "octran.h"

void DUP ()
{	PUSH;
	mnem("mov"); B; A; NL;
}

void FMUL ()
{	/* 32 * 32 -> 64 signed product */
	if (o_hardware)
	{	mnem("smul"); B; A; T0; NL;
		mnem("mov"); Y; B; nl;
	}
	else
	{	mnem("mov"); A; P0; NL;
		extcall(X_MUL); nl;
		mnem("mov"); B; P1; DELAY; nl;
		mnem("mov"); P1; B; nl;
		mnem("mov"); P0; T0; nl;
	}
	/* 64-bit << 1 */
	mnem("addcc"); T0; T0; T0; COMMENT("carry := msb"); nl;
	mnem("addxcc"); B; B; B; COMMENT("B*2 + carry"); nl;
	CHECK;
	/* rounding */
	mnem("addcc"); T0; MIN; T0; nl;
	mnem("addx"); B; dec(0); B; nl;
	mnem("be,a"); f(1); nl;
	mnem("andn"); B; dec(1); B; nl;
lab(1);	nl;
	POP;
}

void CRCWORD ()
{	mnem("mov"); dec(BitsPerWord); T0; NL;
lab(1);	mnem("addcc"); A; A; A; nl;
	mnem("addxcc"); B; B; B; nl;
	mnem("bcs,a"); f(2); nl;
	mnem("xor"); B; C; B; ANNUL; nl;
lab(2);	mnem("deccc"); T0; nl;
	mnem("bg"); b(1); nl;
	mnem("nop"); nl;	/* ??? */
	ishuff = 1;
	POP;
}

void CRCBYTE ()
{	mnem("mov"); dec(BitsPerByte); T0; NL;
lab(1);	mnem("addcc"); A; A; A; nl;
	mnem("addxcc"); B; B; B; nl;
	mnem("bcs,a"); f(2); nl;
	mnem("xor"); B; C; B; ANNUL; nl;
lab(2);	mnem("deccc"); T0; nl;
	mnem("bg"); b(1); nl;
	mnem("nop"); nl;	/* ??? */
	ishuff = 1;
	POP;
}

void BITCNT ()			/* There's a rumour that SPARC-9s have a "popc" instruction */
{	mnem("tst"); A; NL;
	mnem("be"); f(2); nl;
	mnem("nop"); nl;	/* some assemblers don't like ".empty" */
lab(1);	mnem("sub"); A; dec(1); T0; nl;
	mnem("andcc"); A; T0; A; nl;
	mnem("bne"); b(1); nl;
	mnem("inc"); B; DELAY; nl;
lab(2);	nl;
	POP;
}

void BITREVWORD ()
{	mnem("mov"); dec(BitsPerWord); T1; NL;
lab(1);	mnem("and"); A; dec(1); T0; nl;
	mnem("sll"); T2; dec(1); T2; nl;
	mnem("or"); T2; T0; T2; nl;
	mnem("deccc"); T1; nl;
	mnem("bg,a"); b(1); nl;
	mnem("srl"); A; dec(1); A; ANNUL; nl;
	mnem("mov"); T2; A; nl;
}

void BITREVNBITS ()
{	mnem("tst"); A; NL;
	mnem("be"); f(2); nl;
	mnem("clr"); T2; DELAY; nl;
lab(1);	mnem("and"); B; dec(1); T0; nl;
	mnem("sll"); T2; dec(1); T2; nl;
	mnem("or"); T2; T0; T2; nl;
	mnem("deccc"); A; nl;
	mnem("bg,a"); b(1); nl;
	mnem("srl"); B; dec(1); B; ANNUL; nl;
lab(2);	mnem("mov"); T2; B; nl;
	POP;
}

void WSUBDB ()
{	mnem("sll"); B; dec(3); B; NL;
	mnem("add"); B; A; B; nl;
	POP;
}
