/*
 * KROC SPARC translator: Special instructions for the T9000.
 *
 * $Source: /extra/play/cvs/kroc/src/target/sparc/f_t9000.c,v $
 *
 * $Id: f_t9000.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * SPARC target only.
 */

static char f_t9000_c_rcsid[] = "$Id: f_t9000.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $";

#include "octran.h"

void CAUSEERROR ()
{
/*	mnem("cmp"); A; dec(13); NL;	*/
/*	check (C_GEU, T_RANGE); nl;	*/
	mnem("ta"); dec(T_ZERO + T_SETERR); COMMENT("CAUSEERROR"); NL;
}

void CB ()
{	mnem("add"); A; dec(128); T0; NL;
	mnem("cmp"); T0; dec(256); nl;
	check (C_GEU, T_RANGE);
}

void CBU ()
{	mnem("cmp"); A; dec(256); NL;
	check (C_GEU, T_RANGE);
}

void CS ()
{	mnem("sll"); A; dec(16); T0; NL;
	mnem("sra"); T0; dec(16); T0; nl;
	mnem("cmp"); T0; A; nl;
	check (C_NE, T_RANGE);
}

void CSU ()
{	mnem("sll"); A; dec(16); T0; NL;
	mnem("srl"); T0; dec(16); T0; nl;
	mnem("cmp"); T0; A; nl;
	check (C_NE, T_RANGE);
}

void GTU ()			/* just like GT */
{	mnem("cmp"); B; A;
	if (o_opt)
	{	COMMENT ("remember GU");
		NL;
		cond = C_GU;
	}
	else
	{	NL;
		mnem("bgu,a"); f(1); nl;
		mnem("mov"); TRUE; B; annul("true"); nl;
		mnem("mov"); FALSE; B; COMMENT("false"); nl;
	lab(1); nl;
	}
}

void LBX ()
{	if (o_reverse)
	{	mnem("xor"); A; dec(ByteSelectMask); A; NL; }
	mnem("ldsb"); sindex(Areg, 0); A; NL;
}

void LDCNT ()
{	PUSH;
	mnem("ld"); sindex(Wptr, pw_Length); A; NL;
	mnem("cmp"); A; dec(LengthError_p); nl;
	check(C_EQ, T_RANGE);	/* ??? */
}

void LDTH ()			/* what is the trap handler register? */
{	PUSH;
	unimp ();
}

void LS ()
{	if (o_reverse)
	{	mnem("xor"); A; dec(ShortSelectMask); A; NL; }
	mnem("lduh"); sindex(Areg, 0); A; NL;
}

void LSX ()
{	if (o_reverse)
	{	mnem("xor"); A; dec(ShortSelectMask); A; NL; }
	mnem("ldsh"); sindex(Areg, 0); A; NL;
}

void SS ()
{	if (o_reverse)
	{	mnem("xor"); A; dec(ShortSelectMask); A; NL; }
	mnem("sth"); B; sindex(Areg, 0); NL;
	pop (2);
}

void SSUB ()
{	mnem("sll"); B; dec(1); B; NL;
	mnem("add"); B; A; B; nl;
	POP;
}

void XSWORD ()
{	mnem("sll"); A; dec(16); A; NL;
	mnem("sra"); A; dec(16); A; nl;
}

void VIN ()
{	extcall(X_VIN); NL;
	ADJUST; nl;
	istackp = 0;
	ishuff = 0;
}

void VOUT ()
{	extcall(X_VOUT); NL;
	ADJUST; nl;
	istackp = 0;
	ishuff = 0;
}

#ifdef FLOAT

void FPADDDBSN ()
{	fscheck (F_D);
	fscheck (FBtype);
	mnem("faddd"); FBH; FAH; FBH; NL;
	mnem("fdtos"); FBH; FBH; nl;
	FBtype = F_S;
	fstackp -= 1;
}

void FPGE ()
{	fscheck (FBtype);
	PUSH;
	if (o_checks == CH_TRAP)
		fmnem("fcmpe");
	else
		fmnem("fcmp");
	FBH; FAH; COMMENT ("remember FGE"); NL;
	mnem("nop"); nl;
	fround (R_N);
	cond = C_FGE;
	fstackp -= 2;
}

void FPLG ()
{	fscheck (FBtype);
	PUSH;
	if (o_checks == CH_TRAP)
		fmnem("fcmpe");
	else
		fmnem("fcmp");
	FBH; FAH; COMMENT ("remember FLG"); NL;
	mnem("nop"); nl;
	fround (R_N);
	cond = C_FLG;
	fstackp -= 2;
}

void FPREM ()
{	fscheck (FBtype);

/*	The following ought to work in all cases	*/
/*	Independent of rounding mode			*/
/*	(IEEE 754-1895 5.1 and CWG p.58)		*/

	if (SNGL)
	{	mnem("fstod"); FAH; FAH; NL;
		mnem("fstod"); FBH; FBH; nl;
	}
	mnem("std"); FBH; FPtemp; NL;		/* B\A */
	mnem("ldd"); FPtemp; P0; nl;
	mnem("std"); FAH; FPtemp; nl;
	mnem("ldd"); FPtemp; P2; nl;
	extcall(X_REMAINDER); nl;	/* Unix math library */
	if (fstackp == 3)
	{	if (SNGL)
		{	mnem("st"); FCH; FPtemp; delay("save FC"); nl; }
		else
		{	mnem("std"); FCH; FPtemp; delay("save FC"); nl; }
	}
	else
	{	mnem("nop"); nl; }		/* not optimal */
	extcall(X_FPCONST); COMMENT("restore f.p. registers"); nl;
	if (fstackp == 3)			/* result in %f0 = FC */
	{	if (SNGL)
		{	mnem("fdtos"); FCH; FBH; DELAY; nl;
			mnem("ld"); FPtemp; FCH; COMMENT("restore FC"); nl;
		}
		else
		{	mnem("faddd"); FCH; ZERO; FBH; DELAY; nl;
			mnem("ldd"); FPtemp; FCH; COMMENT("restore FC"); nl;
		}
	}
	else /* fstackp == 2 */			/* result in %f0 = FB */
	{	if (SNGL)
		{	mnem("fdtos"); FBH; FBH; DELAY; nl; }
		else
		{	mnem("nop"); nl; }
	}
	fstackp -= 1;

#ifdef UNDEFINED

/*	Short cut for representable quotients	*/
/*	Would be better in double throughout	*/

	fround (R_N);
	fmnem("fdiv"); FBH; FAH; FTH; NL;	/* t = b/a */
	fmnem("fcmp"); FTH; ZERO; nl;		/* t = ROUND(t) */
	mnem("fabss"); FTH; FTH; nl;
	fmnem("fadd"); FTH; MAGIC; FTH; nl;
	fmnem("fsub"); FTH; MAGIC; FTH; nl;
	mnem("nop"); COMMENT("shouldn't be necessary"); nl;
	mnem("fbl,a"); f(1); COMMENT("restore sign"); nl;
	mnem("fnegs"); FTH; FTH; ANNUL; nl;
lab(1);	fmnem("fmul"); FTH; FAH; FTH; nl;	/* t = t*a */
	fmnem("fsub"); FBH; FTH; FBH; nl;	/* a' = b - t */
	fstackp -= 1;

#endif /* UNDEFINED */

}

#endif /* FLOAT */
